package ${packagePath}.service.http;

import ${apiPackagePath}.model.${entity.name};

import aQute.bnd.annotation.ProviderType;

import com.liferay.portal.kernel.json.JSONArray;
import com.liferay.portal.kernel.json.JSONFactoryUtil;
import com.liferay.portal.kernel.json.JSONObject;

import java.util.Date;
import java.util.List;

/**
 * @author ${author}
 * @generated
 */
@ProviderType
public class ${entity.name}JSONSerializer {

	public static JSONObject toJSONObject(${entity.name} model) {
		JSONObject jsonObject = JSONFactoryUtil.createJSONObject();

		<#list entity.regularColList as column>
			<#if stringUtil.equals(column.type, "Date")>
				Date ${column.name} = model.get${column.methodName}();

				String ${column.name}JSON = "";

				if (${column.name} != null) {
					${column.name}JSON = String.valueOf(${column.name}.getTime());
				}

				jsonObject.put("${column.name}", ${column.name}JSON);
			<#else>
				jsonObject.put("${column.name}", model.get${column.methodName}());
			</#if>
		</#list>

		return jsonObject;
	}

	public static JSONArray toJSONArray(${apiPackagePath}.model.${entity.name}[] models) {
		JSONArray jsonArray = JSONFactoryUtil.createJSONArray();

		for (${entity.name} model : models) {
			jsonArray.put(toJSONObject(model));
		}

		return jsonArray;
	}

	public static JSONArray toJSONArray(${apiPackagePath}.model.${entity.name}[][] models) {
		JSONArray jsonArray = JSONFactoryUtil.createJSONArray();

		for (${entity.name}[] model : models) {
			jsonArray.put(toJSONArray(model));
		}

		return jsonArray;
	}

	public static JSONArray toJSONArray(List<${apiPackagePath}.model.${entity.name}> models) {
		JSONArray jsonArray = JSONFactoryUtil.createJSONArray();

		for (${entity.name} model : models) {
			jsonArray.put(toJSONObject(model));
		}

		return jsonArray;
	}

}